/**
 * Copyright(c) Juho Muhonen 2004-2005
 * 
 * This file is part of 'firm'.
 * 
 * 'firm' is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * 'firm' is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with 'firm'; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef FIRM_ASSOCIATIONRULE
#define FIRM_ASSOCIATIONRULE

#include <iostream>
using std::ostream;

#include <vector>
using std::vector;

class FITree;

class AssociationRule {
public:
	FITree* itemset;
	FITree* condition;
	FITree* consequent;

public:
	static int CREATIONS;
	static int DELETIONS;

	AssociationRule();
	AssociationRule(FITree*, FITree*, FITree*);
	AssociationRule(const AssociationRule&);
	~AssociationRule();

	void store();
	vector<AssociationRule*>* conditionSubrules();
	vector<AssociationRule*>* consequentSubrules();
	
	friend ostream& operator<<(ostream&, const AssociationRule&);
};

ostream& operator<<(ostream&, const AssociationRule&);
#endif
